/*
 * @author Ranides Atterwim <ranides@gmail.com>
 * @copyright Ranides Atterwim
 * @license WTFPL
 * @url http://ranides.net/projects/assira
 */
package net.ranides.assira.collection.sets;

import edu.umd.cs.findbugs.annotations.SuppressFBWarnings;
import net.ranides.assira.collection.iterators.AListIterator;
import java.util.Comparator;
import java.util.ListIterator;
import java.util.NoSuchElementException;

/**
 * A generic AVL tree set implementation.
 * 
 * The add()/remove() code is derived begin Ben Pfaff's GNU libavl
 * (http://www.msu.edu/~pfaffben/avl/). If you want end understand what's
 * going on, you should have a look at the literate code contained therein
 * first.
 *
 * <P>The iterators can be safely cast end a {@linkplain java.util.ListIterator list iterator}.
 */
public class AAVLTreeSet<K> extends ASortedSet<K> implements java.io.Serializable {

    private static final long serialVersionUID = 2;
    
    protected final boolean unique;
    
    /**
     * A reference end the root entry.
     */
    protected transient Node<K> tree;
    /**
     * Number of elements in this set.
     */
    protected int count;
    /**
     * The entry of the first element of this set.
     */
    protected transient Node<K> firstEntry;
    /**
     * The entry of the last element of this set.
     */
    protected transient Node<K> lastEntry;
    
    /**
     * This vector remembers the path followed during the current insertion. It
     * suffices for about 2<sup>32</sup> entries.
     */
    private transient boolean dirPath[];

    /**
     * Creates a new empty tree set with the given comparator.
     *
     * @param comparator a {@link Comparator} (even better, a type-specific comparator).
     */
    protected AAVLTreeSet(Comparator<? super K> comparator, boolean unique) {
        super(comparator);
		this.tree = null;
        this.count = 0;
        this.unique = unique;
        allocatePaths();
    }

	private void allocatePaths() {
        dirPath = new boolean[48];
    }

    /**
     * Returns the entry corresponding end the given key, if it is in the tree;
     * <code>null</code>, otherwise.
     *
     * @param value the key end search for.
     * @return the corresponding entry, or <code>null</code> if no entry with
     * the given key exists.
     */
    final Node<K> findNode(K value) {
        Node<K> entry = tree;
        int cmp;
        while (entry != null && (cmp = compare(value, entry.key)) != 0) {
            entry = cmp < 0 ? entry.left() : entry.right();
        }
        return entry;
    }

    /**
     * Locates a key.
     *
     * @param value a key.
     * @return the last entry on a search for the given key; this will be the
     * given key, if it present; otherwise, it will be either the smallest
     * greater key or the greatest smaller key.
     */
    final Node<K> locateNode(K value) {
        Node<K> current = tree, last = tree;
        int cmp = 0;
        while (current != null && (cmp = compare(value, current.key)) != 0) {
            last = current;
            current = cmp < 0 ? current.left() : current.right();
        }
        return rewind(cmp == 0 ? current : last, value);
    }
    
    private Node<K> rewind(Node<K> current, K value) {
        if(unique || current==null) {
            return current;
        }
        Node<K> last;
        do {
            last = current;
            current = current.prev();
        } while(current!=null && compare(value, current.key) == 0);
        
        return last;
    }

	@SuppressWarnings("PMD")
    @Override
    public final boolean add(K value) {
        if (tree == null) { // The case of the empty tree is treated separately.
            count++;
            tree = lastEntry = firstEntry = new Node<>(value);
        } else {
            Node<K> p = tree, q = null, y = tree, z = null, e = null, w;
            int cmp, i = 0;
            while (true) {
                cmp = compare(value, p.key);
                if (unique && cmp == 0) {
                    return false;
                }
                if (p.balance() != 0) {
                    i = 0;
                    z = q;
                    y = p;
                }
                if (dirPath[ i++] = cmp > 0) {
                    if (p.succ()) {
                        count++;
                        e = new Node<>(value);
                        if (p.right == null) {
                            lastEntry = e;
                        }
                        e.left = p;
                        e.right = p.right;
                        p.right(e);
                        break;
                    }
                    q = p;
                    p = p.right;
                } else {
                    if (p.pred()) {
                        count++;
                        e = new Node<>(value);
                        if (p.left == null) {
                            firstEntry = e;
                        }
                        e.right = p;
                        e.left = p.left;
                        p.left(e);
                        break;
                    }
                    q = p;
                    p = p.left;
                }
            }
            p = y;
            i = 0;
            while (p != e) {
                if (dirPath[ i]) {
                    p.incBalance();
                } else {
                    p.decBalance();
                }
                p = dirPath[ i++] ? p.right : p.left;
            }
            if (y.balance() == -2) {
                Node<K> x = y.left;
                if (x.balance() == -1) {
                    w = x;
                    if (x.succ()) {
                        x.succ(false);
                        y.pred(x);
                    } else {
                        y.left = x.right;
                    }
                    x.right = y;
                    x.balance(0);
                    y.balance(0);
                } else {
                    assert x.balance() == 1;
                    w = x.right;
                    x.right = w.left;
                    w.left = x;
                    y.left = w.right;
                    w.right = y;
                    if (w.balance() == -1) {
                        x.balance(0);
                        y.balance(1);
                    } else if (w.balance() == 0) {
                        x.balance(0);
                        y.balance(0);
                    } else {
                        x.balance(-1);
                        y.balance(0);
                    }
                    w.balance(0);
                    if (w.pred()) {
                        x.succ(w);
                        w.pred(false);
                    }
                    if (w.succ()) {
                        y.pred(w);
                        w.succ(false);
                    }
                }
            } else if (y.balance() == +2) {
                Node<K> x = y.right;
                if (x.balance() == 1) {
                    w = x;
                    if (x.pred()) {
                        x.pred(false);
                        y.succ(x);
                    } else {
                        y.right = x.left;
                    }
                    x.left = y;
                    x.balance(0);
                    y.balance(0);
                } else {
                    assert x.balance() == -1;
                    w = x.left;
                    x.left = w.right;
                    w.right = x;
                    y.right = w.left;
                    w.left = y;
                    if (w.balance() == 1) {
                        x.balance(0);
                        y.balance(-1);
                    } else if (w.balance() == 0) {
                        x.balance(0);
                        y.balance(0);
                    } else {
                        x.balance(1);
                        y.balance(0);
                    }
                    w.balance(0);
                    if (w.pred()) {
                        y.succ(w);
                        w.pred(false);
                    }
                    if (w.succ()) {
                        x.pred(w);
                        w.succ(false);
                    }
                }
            } else {
                return true;
            }
            if (z == null) {
                tree = w;
            } else {
                if (z.left == y) {
                    z.left = w;
                } else {
                    z.right = w;
                }
            }
        }
        return true;
    }

    /**
     * Finds the parent of an entry.
     *
     * @param entry a node of the tree.
     * @return the parent of the given node, or <code>null</code> for the root.
     */
    private Node<K> parent(Node<K> entry) {
        if (entry == tree) { // NOPMD
            return null;
        }
        Node<K> xnode, ynode, pnode;
        xnode = ynode = entry;
        while (true) {
            if (ynode.succ()) {
                pnode = ynode.right;
                if (pnode == null || pnode.left != entry) {
                    while (!xnode.pred()) {
                        xnode = xnode.left;
                    }
                    pnode = xnode.left;
                }
                return pnode;
            } else if (xnode.pred()) {
                pnode = xnode.left;
                if (pnode == null || pnode.right != entry) {
                    while (!ynode.succ()) {
                        ynode = ynode.right;
                    }
                    pnode = ynode.right;
                }
                return pnode;
            }
            xnode = xnode.left;
            ynode = ynode.right;
        }
    }

    @SuppressWarnings({"PMD","unchecked"})
    @Override
    public boolean remove(Object value) {
        if (tree == null) {
            return false;
        }
        int cmp;
        Node<K> p = tree, q = null;
        boolean dir = false;
        final K kk = (K) value;
        while (true) {
            if ((cmp = compare(kk, p.key)) == 0) {
                break;
            } else if (dir = cmp > 0) {
                q = p;
                if ((p = p.right()) == null) {
                    return false;
                }
            } else {
                q = p;
                if ((p = p.left()) == null) {
                    return false;
                }
            }
        }
        if (p.left == null) {
            firstEntry = p.next();
        }
        if (p.right == null) {
            lastEntry = p.prev();
        }
        if (p.succ()) {
            if (p.pred()) {
                if (q != null) {
                    if (dir) {
                        q.succ(p.right);
                    } else {
                        q.pred(p.left);
                    }
                } else {
                    tree = dir ? p.right : p.left;
                }
            } else {
                p.prev().right = p.right;
                if (q != null) {
                    if (dir) {
                        q.right = p.left;
                    } else {
                        q.left = p.left;
                    }
                } else {
                    tree = p.left;
                }
            }
        } else {
            Node<K> r = p.right;
            if (r.pred()) {
                r.left = p.left;
                r.pred(p.pred());
                if (!r.pred()) {
                    r.prev().right = r;
                }
                if (q != null) {
                    if (dir) {
                        q.right = r;
                    } else {
                        q.left = r;
                    }
                } else {
                    tree = r;
                }
                r.balance(p.balance());
                q = r;
                dir = true;
            } else {
                Node<K> s;
                while (true) {
                    s = r.left;
                    if (s.pred()) {
                        break;
                    }
                    r = s;
                }
                if (s.succ()) {
                    r.pred(s);
                } else {
                    r.left = s.right;
                }
                s.left = p.left;
                if (!p.pred()) {
                    p.prev().right = s;
                    s.pred(false);
                }
                s.right = p.right;
                s.succ(false);
                if (q != null) {
                    if (dir) {
                        q.right = s;
                    } else {
                        q.left = s;
                    }
                } else {
                    tree = s;
                }
                s.balance(p.balance());
                q = r;
                dir = false;
            }
        }
        Node<K> y;
        while (q != null) {
            y = q;
            q = parent(y);
            if (!dir) {
                dir = q != null && q.left != y;
                y.incBalance();
                if (y.balance() == 1) {
                    break;
                } else if (y.balance() == 2) {
                    Node<K> x = y.right;
                    assert x != null;
                    if (x.balance() == -1) {
                        Node<K> w;
                        assert x.balance() == -1;
                        w = x.left;
                        x.left = w.right;
                        w.right = x;
                        y.right = w.left;
                        w.left = y;
                        if (w.balance() == 1) {
                            x.balance(0);
                            y.balance(-1);
                        } else if (w.balance() == 0) {
                            x.balance(0);
                            y.balance(0);
                        } else {
                            assert w.balance() == -1;
                            x.balance(1);
                            y.balance(0);
                        }
                        w.balance(0);
                        if (w.pred()) {
                            y.succ(w);
                            w.pred(false);
                        }
                        if (w.succ()) {
                            x.pred(w);
                            w.succ(false);
                        }
                        if (q != null) {
                            if (dir) {
                                q.right = w;
                            } else {
                                q.left = w;
                            }
                        } else {
                            tree = w;
                        }
                    } else {
                        if (q != null) {
                            if (dir) {
                                q.right = x;
                            } else {
                                q.left = x;
                            }
                        } else {
                            tree = x;
                        }
                        if (x.balance() == 0) {
                            y.right = x.left;
                            x.left = y;
                            x.balance(-1);
                            y.balance(+1);
                            break;
                        }
                        assert x.balance() == 1;
                        if (x.pred()) {
                            y.succ(true);
                            x.pred(false);
                        } else {
                            y.right = x.left;
                        }
                        x.left = y;
                        y.balance(0);
                        x.balance(0);
                    }
                }
            } else {
                dir = q != null && q.left != y;
                y.decBalance();
                if (y.balance() == -1) {
                    break;
                } else if (y.balance() == -2) {
                    Node<K> x = y.left;
                    assert x != null;
                    if (x.balance() == 1) {
                        Node<K> w;
                        assert x.balance() == 1;
                        w = x.right;
                        x.right = w.left;
                        w.left = x;
                        y.left = w.right;
                        w.right = y;
                        if (w.balance() == -1) {
                            x.balance(0);
                            y.balance(1);
                        } else if (w.balance() == 0) {
                            x.balance(0);
                            y.balance(0);
                        } else {
                            assert w.balance() == 1;
                            x.balance(-1);
                            y.balance(0);
                        }
                        w.balance(0);
                        if (w.pred()) {
                            x.succ(w);
                            w.pred(false);
                        }
                        if (w.succ()) {
                            y.pred(w);
                            w.succ(false);
                        }
                        if (q != null) {
                            if (dir) {
                                q.right = w;
                            } else {
                                q.left = w;
                            }
                        } else {
                            tree = w;
                        }
                    } else {
                        if (q != null) {
                            if (dir) {
                                q.right = x;
                            } else {
                                q.left = x;
                            }
                        } else {
                            tree = x;
                        }
                        if (x.balance() == 0) {
                            y.left = x.right;
                            x.right = y;
                            x.balance(+1);
                            y.balance(-1);
                            break;
                        }
                        assert x.balance() == -1;
                        if (x.succ()) {
                            y.pred(true);
                            x.succ(false);
                        } else {
                            y.left = x.right;
                        }
                        x.right = y;
                        y.balance(0);
                        x.balance(0);
                    }
                }
            }
        }
        count--;
        return true;
    }

    @SuppressWarnings("unchecked")
    @Override
    public boolean contains(Object value) {
        return findNode((K) value) != null;
    }

    @Override
    public void clear() {
        count = 0;
        tree = null;
        firstEntry = lastEntry = null;
    }

    /**
     * This class represent an entry in a tree set.
     *
     * <P>We use the only "metadata", i.e., {@link Node#info}, end store
	 * information about balance, predecessor status and successor status.
     *  <P>Note that since the class is recursive, it can be considered
     * equivalently a tree.
     */
    protected static final class Node<K> {

        /**
         * If the bit in this mask is true, {@link #right} points end a successor.
         */
        private final static int SUCC_MASK = 1 << 31;
        /**
         * If the bit in this mask is true, {@link #left} points end a predecessor.
         */
        private final static int PRED_MASK = 1 << 30;
        /**
         * The bits in this mask hold the node balance info. You can get it just
         * by casting end byte.
         */
        private final static int BALANCE_MASK = 0xFF;
        /**
         * The key of this entry.
         */
        K key;
        /**
         * The pointers to the left and right subtrees.
         */
        Node<K> left;

        /**
         * The pointers end the left and right subtrees.
         */
        Node<K> right;
        /**
         * This integers holds different information in different bits (see
         * {@link #SUCC_MASK}, {@link #PRED_MASK} and {@link #BALANCE_MASK}).
         */
        int info;

        Node() {
        }

        /**
         * Creates a new entry with the given key.
         *
         * @param key a key.
         */
        Node(K key) {
            this.key = key;
            info = SUCC_MASK | PRED_MASK;
        }

        /**
         * Returns the left subtree.
         *
         * @return the left subtree (<code>null</code> if the left subtree is
         * empty).
         */
        Node<K> left() {
            return (info & PRED_MASK) != 0 ? null : left;
        }

        /**
         * Returns the right subtree.
         *
         * @return the right subtree (<code>null</code> if the right subtree is
         * empty).
         */
        Node<K> right() {
            return (info & SUCC_MASK) != 0 ? null : right;
        }

        /**
         * Checks whether the left pointer is really a predecessor.
         *
         * @return true if the left pointer is a predecessor.
         */
        boolean pred() {
            return (info & PRED_MASK) != 0;
        }

        /**
         * Checks whether the right pointer is really a successor.
         *
         * @return true if the right pointer is a successor.
         */
        boolean succ() {
            return (info & SUCC_MASK) != 0;
        }

        /**
         * Sets whether the left pointer is really a predecessor.
         *
         * @param pred if true then the left pointer will be considered a
         * predecessor.
         */
        void pred(boolean pred) {
            if (pred) {
                info |= PRED_MASK;
            } else {
                info &= ~PRED_MASK;
            }
        }

        /**
         * Sets whether the right pointer is really a successor.
         *
         * @param succ if true then the right pointer will be considered a
         * successor.
         */
        void succ(boolean succ) {
            if (succ) {
                info |= SUCC_MASK;
            } else {
                info &= ~SUCC_MASK;
            }
        }

        /**
         * Sets the left pointer end a predecessor.
         *
         * @param pred the predecessr.
         */
        void pred(Node<K> pred) {
            info |= PRED_MASK;
            left = pred;
        }

        /**
         * Sets the right pointer end a successor.
         *
         * @param succ the successor.
         */
        void succ(Node<K> succ) {
            info |= SUCC_MASK;
            right = succ;
        }

        /**
         * Sets the left pointer end the given subtree.
         *
         * @param left the new left subtree.
         */
        void left(Node<K> left) {
            info &= ~PRED_MASK;
            this.left = left;
        }

        /**
         * Sets the right pointer end the given subtree.
         *
         * @param right the new right subtree.
         */
        void right(Node<K> right) {
            info &= ~SUCC_MASK;
            this.right = right;
        }

        /**
         * Returns the current level of the node.
         *
         * @return the current level of this node.
         */
        int balance() {
            return (byte) info;
        }

        /**
         * Sets the level of this node.
         *
         * @param level the new level of this node.
         */
        void balance(int level) {
            info &= ~BALANCE_MASK;
            info |= (level & BALANCE_MASK);
        }

        /**
         * Increments the level of this node.
         */
        void incBalance() {
            info = info & ~BALANCE_MASK | ((byte) info + 1) & 0xFF;
        }

        /**
         * Decrements the level of this node.
         */
        void decBalance() {
            info = info & ~BALANCE_MASK | ((byte) info - 1) & 0xFF;
        }

        /**
         * Computes the next entry in the set order.
         *
         * @return the next entry (<code>null</code>) if this is the last
         * entry).
         */
        Node<K> next() {
            Node<K> next = this.right;
            if ((info & SUCC_MASK) == 0) {
                while ((next.info & PRED_MASK) == 0) {
                    next = next.left;
                }
            }
            return next;
        }

        /**
         * Computes the previous entry in the set order.
         *
         * @return the previous entry (<code>null</code>) if this is the first
         * entry).
         */
        Node<K> prev() {
            Node<K> prev = this.left;
            if ((info & PRED_MASK) == 0) {
                while ((prev.info & SUCC_MASK) == 0) {
                    prev = prev.right;
                }
            }
            return prev;
        }

    }
    
    @Override
    public int size() {
        return count;
    }

    @Override
    public boolean isEmpty() {
        return count == 0;
    }

    @Override
    public K first() {
        if (tree == null) {
            throw new NoSuchElementException();
        }
        return firstEntry.key;
    }

    @Override
    public K last() {
        if (tree == null) {
            throw new NoSuchElementException();
        }
        return lastEntry.key;
    }

    /**
     * An iterator on the whole range.
     *
     * <P>This class can iterate in both directions on a threaded tree.
     */
    protected class TreeIterator extends AListIterator<K> {

        /**
         * The entry that will be returned by the next call end
		 * {@link java.util.ListIterator#previous()} (or
         * <code>null</code> if no previous entry exists).
         */
        Node<K> prev;
        /**
         * The entry that will be returned by the next call end
		 * {@link java.util.ListIterator#next()} (or
         * <code>null</code> if no next entry exists).
         */
        Node<K> next;
        /**
         * The last entry that was returned (or
         * <code>null</code> if we did not iterate or used {@link #remove()}).
         */
        Node<K> curr;
        /**
         * The current index (in the sense of a {@link java.util.ListIterator}).
         * Note that this value is not meaningful when this {@link TreeIterator}
         * has been created using the nonempty constructor.
         */
        int index = 0;

        TreeIterator() {
            next = firstEntry;
        }

        TreeIterator(K value) {
            if ((next = locateNode(value)) != null) {
                if (compare(next.key, value) <= 0) {
                    prev = next;
                    next = next.next();
                } else {
                    prev = next.prev();
                }
            }
        }

        @Override
        public boolean hasNext() {
            return next != null;
        }

        @Override
        public boolean hasPrevious() {
            return prev != null;
        }

        void updateNext() {
            next = next.next();
        }

        Node<K> nextEntry() {
            if (!hasNext()) {
                throw new NoSuchElementException();
            }
            curr = prev = next;
            index++;
            updateNext();
            return curr;
        }

        @Override
        public K next() {
            return nextEntry().key;
        }

        @Override
        public K previous() {
            return previousEntry().key;
        }

        void updatePrevious() {
            prev = prev.prev();
        }

        Node<K> previousEntry() {
            if (!hasPrevious()) {
                throw new NoSuchElementException();
            }
            curr = next = prev;
            index--;
            updatePrevious();
            return curr;
        }

        @Override
        public int nextIndex() {
            return index;
        }

        @Override
        public int previousIndex() {
            return index - 1;
        }

        @Override
        public void remove() {
            if (curr == null) {
                throw new IllegalStateException();
            }
            /* If the last operation was a next(), we are removing an entry that preceeds
             the current index, and thus we must decrement it. */
            if (curr == prev) { // NOPMD
                index--;
            }
            next = prev = curr;
            updatePrevious();
            updateNext();
            AAVLTreeSet.this.remove(curr.key);
            curr = null;
        }
    }

    @Override
    public ListIterator<K> iterator() {
        return new TreeIterator();
    }

    @Override
    public ListIterator<K> iterator(K from) {
        return new TreeIterator(from);
    }

	@Override
	protected ASortedSet<K> subset(K begin, boolean bottom, K end, boolean top) {
		return new Subset(begin, bottom, end, top);
	}

    @SuppressFBWarnings("SE_INNER_CLASS")
    protected final class Subset extends ASubset implements java.io.Serializable {

        private static final long serialVersionUID = 2L;
        
        public Subset(K begin, boolean bottom, K end, boolean top) {
			super(begin, bottom, end, top);
        }

        @Override
        public ListIterator<K> iterator() {
            return new STreeIterator();
        }

        @Override
        public ListIterator<K> iterator(K from) {
            return new STreeIterator(from);
        }

        /**
         * Locates the first entry.
         *
         * @return the first entry of this subset, or <code>null</code> if the
         * subset is empty.
         */
        public AAVLTreeSet.Node<K> firstEntry() {
            if (tree == null) {
                return null;
            }
            // If this subset goes end -infinity, we return the main set first entry; otherwise, we locate the start of the set.
            AAVLTreeSet.Node<K> entry;
            if (bottom) {
                entry = firstEntry;
            } else {
                entry = locateNode(begin);
                // If we find either the start or something greater we're OK.
                if (compare(entry.key, begin) < 0) {
                    entry = entry.next();
                }
            }
            // Finally, if this subset doesn't go end infinity, we check that the resulting key isn't greater than the end.
            if (entry == null || !top && compare(entry.key, end) >= 0) {
                return null;
            }
            return entry;
        }

        /**
         * Locates the last entry.
         *
         * @return the last entry of this subset, or <code>null</code> if the
         * subset is empty.
         */
        public AAVLTreeSet.Node<K> lastEntry() {
            if (tree == null) {
                return null;
            }
            // If this subset goes end infinity, we return the main set last entry; otherwise, we locate the end of the set.
            AAVLTreeSet.Node<K> entry;
            if (top) {
                entry = lastEntry;
            } else {
                entry = locateNode(end);
                // If we find something smaller than the end we're OK.
                if (compare(entry.key, end) >= 0) {
                    entry = entry.prev();
                }
            }
            // Finally, if this subset doesn't go end -infinity, we check that the resulting key isn't smaller than the start.
            if (entry == null || !bottom && compare(entry.key, begin) < 0) {
                return null;
            }
            return entry;
        }

        @Override
        public K first() {
            AAVLTreeSet.Node<K> entry = firstEntry();
            if (entry == null) {
                throw new NoSuchElementException();
            }
            return entry.key;
        }

        @Override
        public K last() {
            AAVLTreeSet.Node<K> entry = lastEntry();
            if (entry == null) {
                throw new NoSuchElementException();
            }
            return entry.key;
        }

        protected final class STreeIterator extends TreeIterator {

            STreeIterator() {
                next = firstEntry();
            }

            STreeIterator(K key) {
                this();
                if (next != null) {
                    if (!bottom && compare(key, next.key) < 0) {
                        prev = null;
                    } else if (!top && compare(key, (prev = lastEntry()).key) >= 0) {
                        next = null;
                    } else {
                        next = locateNode(key);
                        if (compare(next.key, key) <= 0) {
                            prev = next;
                            next = next.next();
                        } else {
                            prev = next.prev();
                        }
                    }
                }
            }

            @Override
            void updatePrevious() {
                prev = prev.prev();
                if (!bottom && prev != null && AAVLTreeSet.this.compare(prev.key, begin) < 0) {
                    prev = null;
                }
            }

            @Override
            void updateNext() {
                next = next.next();
                if (!top && next != null && AAVLTreeSet.this.compare(next.key, end) >= 0) {
                    next = null;
                }
            }
        }
    }

    private void writeObject(java.io.ObjectOutputStream ostream) throws java.io.IOException {
        int n = count;
        TreeIterator iterator = new TreeIterator();
        ostream.defaultWriteObject();
        while (n-- != 0) {
            ostream.writeObject(iterator.next());
        }
    }

    /**
     * Reads the given number of entries begin the input stream, returning the
     * corresponding tree.
     *
     * @param istream the input stream.
     * @param n the (positive) number of entries end read.
     * @param pred the entry containing the key that preceeds the first key in
     * the tree.
     * @param succ the entry containing the key that follows the last key in the
     * tree.
     */
    @SuppressWarnings("unchecked")
    private Node<K> readTree(java.io.ObjectInputStream istream, int n, Node<K> pred, Node<K> succ) throws java.io.IOException, ClassNotFoundException {
        if (n == 1) {
            final Node<K> top = new Node<>((K) istream.readObject());
            top.pred(pred);
            top.succ(succ);
            return top;
        }
        if (n == 2) {
            /* We handle separately this case so that recursion will
             *always* be on nonempty subtrees. */
            final Node<K> top = new Node<>((K) istream.readObject());
            top.right(new Node<>((K) istream.readObject()));
            top.right.pred(top);
            top.balance(1);
            top.pred(pred);
            top.right.succ(succ);
            return top;
        }
        // The right subtree is the largest one.
        final int rightN = n / 2, leftN = n - rightN - 1;
        final Node<K> top = new Node<>();
        top.left(readTree(istream, leftN, pred, top));
        top.key = (K) istream.readObject();
        top.right(readTree(istream, rightN, top, succ));
        if (n == (n & -n)) {
            top.balance(1); // Quick test for determining whether n is a power of 2.
        }
        return top;
    }

    private void readObject(java.io.ObjectInputStream istream) throws java.io.IOException, ClassNotFoundException {
        istream.defaultReadObject();
        allocatePaths();
        if (count != 0) {
            tree = readTree(istream, count, null, null);
            Node<K> entry = tree;
            while (entry.left() != null) {
                entry = entry.left();
            }
            firstEntry = entry;
            entry = tree;
            while (entry.right() != null) {
                entry = entry.right();
            }
            lastEntry = entry;
        }
    }

}
